
/* polysyndeton
 * 1999 (c) scut of teso
 *
 * client routines
 */

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pthread.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "client.h"
#include "network.h"
#include "relay.h"

void *
cl_handle (client *cl)
{
	int			n;
	char			buff[1024];
	char			type;	/* type character for gater */
	struct sockaddr_in	csa;

	pthread_mutex_lock (&cl->cl_mutex);
	printf ("[%s:%d] -> [%s:%hu]\n", inet_ntoa (cl->csa.sin_addr), cl->csa.sin_port,
		cl->connip, cl->connport);

	cl->ss = net_connect (&csa, cl->connip, cl->connport, NULL, 0, 25);
	if (cl->ss <= 0) {
		printf ("FAILED\n");
		return (NULL);
	}

	pthread_mutex_unlock (&cl->cl_mutex);

	rly_client (cl);

clerror:
	close (cl->ss);
	close (cl->cs);

	/* the relay handler only exits on failure or connection close request,
	 * either from the remote server or our little client
	 * in any case, we have to terminate the client
	 */

	/* should never happen */
	return (NULL);
}

client *
cl_add (void)
{
	int	n;
	client	*cl;

	cl = (client *) calloc (1, sizeof (client));
	if (cl)
		cl_init (cl);

	return (cl);
}

void
cl_init (client *cl)
{
	pthread_mutex_init (&cl->cl_mutex, NULL);
	return;
}

